IterableSerializer
Date: 2016-12-04

com.fasterxml.jackson.databind.ser.std

## Class IterableSerializer

- java.lang.Object
- - com.fasterxml.jackson.databind.JsonSerializer<T>
  - - com.fasterxml.jackson.databind.ser.std.StdSerializer<T>
    - - com.fasterxml.jackson.databind.ser.ContainerSerializer<T>
      - - com.fasterxml.jackson.databind.ser.std.AsArraySerializerBase<java.lang.Iterable<?>>
        - - com.fasterxml.jackson.databind.ser.std.IterableSerializer

- All Implemented Interfaces:
    JsonFormatVisitable, SchemaAware, ContextualSerializer, java.io.Serializable

      public class IterableSerializer
      extends AsArraySerializerBase<java.lang.Iterable<?>>

  See Also:
    Serialized Form

- - ### Nested Class Summary

    - ### Nested classes/interfaces inherited from class com.fasterxml.jackson.databind.JsonSerializer

      `JsonSerializer.None`

  - ### Field Summary

    - ### Fields inherited from class com.fasterxml.jackson.databind.ser.std.AsArraySerializerBase

      `_dynamicSerializers, _elementSerializer, _elementType, _property, _staticTyping, _unwrapSingle, _valueTypeSerializer`

    - ### Fields inherited from class com.fasterxml.jackson.databind.ser.std.StdSerializer

      `_handledType`

  - ### Constructor Summary

    Constructors
    Constructor and Description
    `IterableSerializer(IterableSerializer src, BeanProperty property, TypeSerializer vts, JsonSerializer<?> valueSerializer, java.lang.Boolean unwrapSingle)`
    `IterableSerializer(JavaType elemType, boolean staticTyping, TypeSerializer vts)`

  - ### Method Summary

    Methods
    Modifier and Type | Method and Description
    --- | ---
    `ContainerSerializer<?>` | `_withValueTypeSerializer(TypeSerializer vts)` Method that needs to be implemented to allow construction of a new serializer object with given `TypeSerializer`, used when addition type information is to be embedded.
    `boolean` | `hasSingleElement(java.lang.Iterable<?> value)` Method called to determine if the given value (of type handled by this serializer) contains exactly one element.
    `boolean` | `isEmpty(SerializerProvider prov, java.lang.Iterable<?> value)` Method called to check whether given serializable value is considered "empty" value (for purposes of suppressing serialization of empty values).
    `void` | `serialize(java.lang.Iterable<?> value, com.fasterxml.jackson.core.JsonGenerator gen, SerializerProvider provider)` Method that can be called to ask implementation to serialize values of type this serializer handles.
    `void` | `serializeContents(java.lang.Iterable<?> value, com.fasterxml.jackson.core.JsonGenerator jgen, SerializerProvider provider)`
    `IterableSerializer` | `withResolved(BeanProperty property, TypeSerializer vts, JsonSerializer<?> elementSerializer, java.lang.Boolean unwrapSingle)`

    - ### Methods inherited from class com.fasterxml.jackson.databind.ser.std.AsArraySerializerBase

      `_findAndAddDynamic, _findAndAddDynamic, acceptJsonFormatVisitor, createContextual, getContentSerializer, getContentType, getSchema, serializeWithType, withResolved`

    - ### Methods inherited from class com.fasterxml.jackson.databind.ser.ContainerSerializer

      `hasContentTypeAnnotation, isEmpty, withValueTypeSerializer`

    - ### Methods inherited from class com.fasterxml.jackson.databind.ser.std.StdSerializer

      `createObjectNode, createSchemaNode, createSchemaNode, findAnnotatedContentSerializer, findConvertingContentSerializer, findFormatFeature, findFormatOverrides, findIncludeOverrides, findPropertyFilter, getSchema, handledType, isDefaultSerializer, visitArrayFormat, visitArrayFormat, visitFloatFormat, visitIntFormat, visitIntFormat, visitStringFormat, visitStringFormat, wrapAndThrow, wrapAndThrow`

    - ### Methods inherited from class com.fasterxml.jackson.databind.JsonSerializer

      `getDelegatee, isUnwrappingSerializer, properties, replaceDelegatee, unwrappingSerializer, usesObjectId, withFilterId`

    - ### Methods inherited from class java.lang.Object

      `clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

- - ### Constructor Detail

    - #### IterableSerializer

          public IterableSerializer(JavaType elemType,
                            boolean staticTyping,
                            TypeSerializer vts)

    - #### IterableSerializer

          public IterableSerializer(IterableSerializer src,
                            BeanProperty property,
                            TypeSerializer vts,
                            JsonSerializer<?> valueSerializer,
                            java.lang.Boolean unwrapSingle)

  - ### Method Detail

    - #### _withValueTypeSerializer

          public ContainerSerializer<?> _withValueTypeSerializer(TypeSerializer vts)

      Description copied from class: `ContainerSerializer`
      Method that needs to be implemented to allow construction of a new serializer object with given `TypeSerializer`, used when addition type information is to be embedded.
      Specified by:
        `_withValueTypeSerializer` in class `ContainerSerializer<java.lang.Iterable<?>>`

    - #### withResolved

          public IterableSerializer withResolved(BeanProperty property,
                                        TypeSerializer vts,
                                        JsonSerializer<?> elementSerializer,
                                        java.lang.Boolean unwrapSingle)

      Specified by:
        `withResolved` in class `AsArraySerializerBase<java.lang.Iterable<?>>`

    - #### isEmpty

          public boolean isEmpty(SerializerProvider prov,
                        java.lang.Iterable<?> value)

      Description copied from class: `JsonSerializer`
      Method called to check whether given serializable value is considered "empty" value (for purposes of suppressing serialization of empty values).

      Default implementation will consider only null values to be empty.

      NOTE: replaces `JsonSerializer.isEmpty(Object)`, which was deprecated in 2.5

      Overrides:
        `isEmpty` in class `JsonSerializer<java.lang.Iterable<?>>`

    - #### hasSingleElement

          public boolean hasSingleElement(java.lang.Iterable<?> value)

      Description copied from class: `ContainerSerializer`
      Method called to determine if the given value (of type handled by this serializer) contains exactly one element.

      Note: although it might seem sensible to instead define something like "getElementCount()" method, this would not work well for containers that do not keep track of size (like linked lists may not).

      Specified by:
        `hasSingleElement` in class `ContainerSerializer<java.lang.Iterable<?>>`

    - #### serialize

          public final void serialize(java.lang.Iterable<?> value,
                       com.fasterxml.jackson.core.JsonGenerator gen,
                       SerializerProvider provider)
                               throws java.io.IOException

      Description copied from class: `JsonSerializer`
      Method that can be called to ask implementation to serialize values of type this serializer handles.
      Overrides:
        `serialize` in class `AsArraySerializerBase<java.lang.Iterable<?>>`
      Parameters:
        `value` - Value to serialize; can not be null.
        `gen` - Generator used to output resulting Json content
        `provider` - Provider that can be used to get serializers for serializing Objects value contains, if any.
      Throws:
        `java.io.IOException`

    - #### serializeContents

          public void serializeContents(java.lang.Iterable<?> value,
                               com.fasterxml.jackson.core.JsonGenerator jgen,
                               SerializerProvider provider)
                                 throws java.io.IOException

      Specified by:
        `serializeContents` in class `AsArraySerializerBase<java.lang.Iterable<?>>`
      Throws:
        `java.io.IOException`